
%define name	flash-player-plugin
%define version	10.3.181.14
%define rel	1

%define distsuffix plf
# backportability
%define _localstatedir /var

Summary:	Flash Player plugin for browsers
Name:		%name
Version:	%version
Release:	%mkrel %rel
License:	Proprietary
URL:		http://www.adobe.com/products/flashplayer/
Source0:	download-flash-player-plugin.in
Group:		Networking/WWW
ExclusiveArch:	%ix86
Requires:	curl
Requires(post):	curl

# obtained by objdump -x /usr/lib/mozilla/plugins/libflashplayer.so | grep NEEDED
# helper: for i in $(objdump -p libflashplayer.so  | grep NEEDED | awk '{ print $2 }'); do
#	  echo -n "$i: "; rpm -qf /usr/lib64/$i; done
#		libX11.so.6	libXext.so.6	libXt.so.6	libfreetype.so.6
Requires:	%{_lib}x11_6	%{_lib}xext6	%{_lib}xt6	%{_lib}freetype6
#		libfontconfig.so.1	libgtk-x11-2.0.so.0, libgdk-x11-2.0.so.0
Requires:       %{_lib}fontconfig1	%{_lib}gtk+-x11-2.0_0
#		libatk-1.0.so.0	libgdk_pixbuf-2.0.so.0	libpangocairo-1.0.so.0, libpango-1.0.so.0
Requires:	%{_lib}atk1.0_0	%{_lib}gdk_pixbuf2.0_0	%{_lib}pango1.0_0
#		libcairo.so.2	libgobject-2.0.so.0, libgmodule-2.0.so.0, libglib-2.0.so.0
Requires:	%{_lib}cairo2	%{_lib}glib2.0_0
#		libnss3.so, libsmime3.so, libssl3.so	libplds4.so, libplc4.so, libnspr4.so
Requires:	%{_lib}nss3				%{_lib}nspr4
# required for audio, dlopened:
Requires:	%{_lib}alsa2
# dlopened:
%if %{mdkversion} >= 200710
Requires:	%{_lib}curl4
%else
Requires:	%{_lib}curl3
%endif
# dlopened, for video acceleration:
Suggests:	%{_lib}vdpau1
#
Conflicts:	FlashPlayer < 9.0.115.0-5
Conflicts:	flash-plugin FlashPlayer-plugin flashplayer-plugin
# Conflict with free plugins to avoid user confusion as to which one is
# actually used:
Conflicts:	gnash-firefox-plugin
Conflicts:	swfdec-mozilla
Conflicts:	lightspark-mozilla-plugin
Conflicts:	libflashsupport < 0.20080000.1
Obsoletes:	flash-player-plugin10.2 < 10.2.152
BuildRequires:	kde4-macros
BuildRoot:	%{_tmppath}/%{name}-root

%description
Adobe Flash Player plugin for browsers.

NOTE: This package does not contain the Flash Player itself. The
software will be automatically downloaded from Adobe during package
installation. Alternatively you can use the command
"download-flash-player-plugin" manually.

Installing this package indicates acceptance of the EULA, available
from http://www.adobe.com/products/eulas/players/flash/.

This package is in PLF because it installs software with non-free
license.

%prep
%setup -c -T

# The linuxdownload.adobe.com rpm usually stays up longer, but fpdownload.macromedia.com is faster.
# Their md5sums differ.
%ifarch %ix86
%define downurl1 http://fpdownload.macromedia.com/get/flashplayer/current/flash-plugin-%version-release.i386.rpm
%define tmd5sum1 257d2a592f416436d49e0322b30b4ef4
%define downurl2 http://linuxdownload.adobe.com/linux/i386/flash-plugin-%version-release.i386.rpm
%define tmd5sum2 257d2a592f416436d49e0322b30b4ef4
%define tarname flash-plugin-%version-release.i386.rpm
%define tartype	rpm
%endif
%ifarch x86_64
%define downurl1 http://download.macromedia.com/pub/labs/flashplayer10/libflashplayer-%version.linux-x86_64.so.tar.gz
%define tmd5sum1 none, not available
%define downurl2 %nil
%define tmd5sum2 %nil
%define tarname libflashplayer-%version.linux-x86_64.so.tar.gz
%define tartype tar
%endif

cat > download-flash-player-plugin <<EOF
#!/bin/sh
TARBALLDIR="%{_localstatedir}/lib/%{name}"
FILENAME="%{tarname}"
FILETYPE="%{tartype}"
MD5SUM1="%{tmd5sum1}"
MD5SUM2="%{tmd5sum2}"
MD5SUM3=
URL1="%{downurl1}"
URL2="%{downurl2}"
URL3=
FILE1_SRC="usr/lib/flash-plugin/libflashplayer.so"
FILE1_DST="%{_libdir}/mozilla/plugins/libflashplayer.so"
FILE2_SRC="usr/lib/flash-plugin/LICENSE"
FILE2_DST="%{_libdir}/mozilla/plugins/LICENSE.flashplayer"
FILE3_SRC="usr/lib/flash-plugin/README"
FILE3_DST="%{_libdir}/mozilla/plugins/README.flashplayer"

FILE4_SRC="usr/bin/flash-player-properties"
FILE4_DST="%{_bindir}/flash-player-properties"
FILE5_SRC="usr/share/applications/flash-player-properties.desktop"
FILE5_DST="%{_datadir}/applications/flash-player-properties.desktop"

FILE6_SRC="usr/share/icons/hicolor/16x16/apps/flash-player-properties.png"
FILE6_DST="%{_iconsdir}/hicolor/16x16/apps/flash-player-properties.png"
FILE7_SRC="usr/share/icons/hicolor/22x22/apps/flash-player-properties.png"
FILE7_DST="%{_iconsdir}/hicolor/22x22/apps/flash-player-properties.png"
FILE8_SRC="usr/share/icons/hicolor/24x24/apps/flash-player-properties.png"
FILE8_DST="%{_iconsdir}/hicolor/24x24/apps/flash-player-properties.png"
FILE9_SRC="usr/share/icons/hicolor/32x32/apps/flash-player-properties.png"
FILE9_DST="%{_iconsdir}/hicolor/32x32/apps/flash-player-properties.png"
FILE10_SRC="usr/share/icons/hicolor/48x48/apps/flash-player-properties.png"
FILE10_DST="%{_iconsdir}/hicolor/48x48/apps/flash-player-properties.png"

FILE11_SRC="usr/lib/kde4/kcm_adobe_flash_player.so"
FILE11_DST="%{_kde_libdir}/kde4/kcm_adobe_flash_player.so"
FILE12_SRC="usr/share/kde4/services/kcm_adobe_flash_player.desktop"
FILE12_DST="%{_kde_services}/kcm_adobe_flash_player.desktop"

FILE13_SRC=

EOF
cat %SOURCE0 >> download-flash-player-plugin

cat >> download-flash-player-plugin <<EOF
%{_bindir}/gtk-update-icon-cache --force --quiet %{_iconsdir}/hicolor &>/dev/null
EOF

%ifarch %ix86
cat >> download-flash-player-plugin <<EOF
if [ "\$(uname -m)" == x86_64 ]; then
	if [ -x %{_bindir}/nspluginwrapper ]; then
		echo "Detected x86_64 with nspluginwrapper, enabling the plugin on 64bit browsers too."
		%{_bindir}/nspluginwrapper -i %{_libdir}/mozilla/plugins/libflashplayer.so
	else
		echo "Install nspluginwrapper if you want to use the plugin with 64bit browsers too."
	fi
	echo "Note: Adobe Flash Player configurator can only be accessed from the normal Tools"
	echo "menu instead of KDE System Settings (due to this being a 64bit system)."
	rm -f %{_kde_services}/kcm_adobe_flash_player.desktop
	sed -i 's,NotShowIn=KDE;,,' %{_datadir}/applications/flash-player-properties.desktop
	# otherwise KDE hides it:
	sed -i 's,GNOME;,,' %{_datadir}/applications/flash-player-properties.desktop
fi
EOF
%endif

%install
rm -rf %{buildroot}

install -d -m755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m755 %{buildroot}%{_libdir}/mozilla/plugins
%if %mdkversion < 200800
install -d -m755 %{buildroot}%{_libdir}/opera/plugins
ln -s %{_libdir}/mozilla/plugins/libflashplayer.so %{buildroot}%{_libdir}/opera/plugins/libflashplayer.so
%endif
touch %{buildroot}%{_libdir}/mozilla/plugins/libflashplayer.so
touch %{buildroot}%{_libdir}/mozilla/plugins/LICENSE.flashplayer
touch %{buildroot}%{_libdir}/mozilla/plugins/README.flashplayer
touch %{buildroot}%{_localstatedir}/lib/%{name}/%{tarname}

install -d -m755 %{buildroot}%{_bindir}
touch %{buildroot}%{_bindir}/flash-player-properties

install -d -m755 %{buildroot}%{_kde_services}
touch %{buildroot}%{_kde_services}/kcm_adobe_flash_player.desktop
install -d -m755 %{buildroot}%{_kde_libdir}/kde4
touch %{buildroot}%{_kde_libdir}/kde4/kcm_adobe_flash_player.so

install -d -m755 %{buildroot}%{_datadir}/applications
touch %{buildroot}%{_datadir}/applications/flash-player-properties.desktop

for i in 16 22 24 32 48; do
	install -d -m755 %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps
	touch %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/flash-player-properties.png
done

install -d -m755 %{buildroot}%{_sbindir}
install -m755 download-flash-player-plugin %{buildroot}%{_sbindir}

%clean
rm -rf %{buildroot}

# posttrans so that we can use postun safely without if's :)
%posttrans
%{_sbindir}/download-flash-player-plugin

%ifarch %ix86
%postun
if [ -x %{_bindir}/nspluginwrapper ] && [ "$(uname -m)" == x86_64 ] && [ -f %{_prefix}/lib64/mozilla/plugins/npwrapper.libflashplayer.so ]; then
	%{_bindir}/nspluginwrapper -r %{_prefix}/lib64/mozilla/plugins/npwrapper.libflashplayer.so
fi
%endif

%files
%defattr(-,root,root)
%{_sbindir}/download-flash-player-plugin
%dir %{_localstatedir}/lib/%{name}
%ghost %{_localstatedir}/lib/%{name}/%{tarname}
%dir %{_libdir}/mozilla
%dir %{_libdir}/mozilla/plugins
%ghost %{_libdir}/mozilla/plugins/libflashplayer.so
%ghost %{_libdir}/mozilla/plugins/LICENSE.flashplayer
%ghost %{_libdir}/mozilla/plugins/README.flashplayer

%ghost %{_bindir}/flash-player-properties
%ghost %{_datadir}/applications/flash-player-properties.desktop
%ghost %{_iconsdir}/hicolor/*/apps/flash-player-properties.png

# Prevent unowned directories on non-KDE systems
%dir %{_kde_libdir}/kde4
%dir %{_datadir}/kde4
%dir %{_kde_services}

%ghost %{_kde_libdir}/kde4/kcm_adobe_flash_player.so
%ghost %{_kde_services}/kcm_adobe_flash_player.desktop

%if %mdkversion < 200800
%{_libdir}/opera
%endif

%changelog
* Fri May 13 2011 Anssi Hannula <anssi@zarb.org> 10.3.181.14-1plf2011.0
- new version
- adapt script for added files
- 32bit KDE now has a settings applet in KDE System Settings, other desktops
  (including 64bit KDE) have a standalone configuration application

* Sat Apr 16 2011 Anssi Hannula <anssi@zarb.org> 10.2.159.1-1plf2011.0
- new version

* Tue Mar 22 2011 Anssi Hannula <anssi@zarb.org> 10.2.153.1-1plf2011.0
- new version

* Wed Feb 09 2011 Anssi Hannula <anssi@zarb.org> 10.2.152.27-1plf2011.0
- new version

* Wed Dec 01 2010 Anssi Hannula <anssi@zarb.org> 10.1.102.65-1plf2011.0
- new version

* Fri Nov 05 2010 Anssi Hannula <anssi@zarb.org> 10.1.102.64-1plf2011.0
- new version (fixes CVE-2010-3654)

* Tue Sep 21 2010 Anssi Hannula <anssi@zarb.org> 10.1.85.3-1plf2011.0
- new version
- conflict with lightspark mozilla plugin

* Thu Aug 12 2010 Anssi Hannula <anssi@zarb.org> 10.1.82.76-1plf2010.1
- new version

* Fri Jun 11 2010 Anssi Hannula <anssi@zarb.org> 10.1.53.64-1plf2010.1
- new version
- remove LAHF workaround, should be fixed upstream
- disable x86_64 build, Adobe no longer provides a 64-bit version

* Tue May 11 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-3plf2010.1
- include a workaround for a crash on non-LAHF x86_64 systems (fixes PLF
  bug #260, workarounds upstream bug FP-1026, workaround by Maks Verver)
- preserve tarball to avoid a redownload after a rebuild
  
* Fri Apr 16 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-2plf2010.1
- conflict with flashplayer-plugin (new name of the mdv pwp package)
- conflict with swfdec-mozilla and gnash-firefox-plugin to avoid user
  confusion as to which one is actually in use (fixes bug #271)

* Thu Feb 18 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-1plf2010.1
- new version

* Fri Dec 11 2009 Anssi Hannula <anssi@zarb.org> 10.0.42.34-1plf2010.1
- new version
- build on x86_64, using the alpha x86_64 build
- use faster fpdownload as primary download host
- conflicts with old libflashsupport

* Sun Aug 02 2009 Anssi Hannula <anssi@zarb.org> 10.0.32.18-1plf2010.0
- new version
- adapt spec for redefined _localstatedir

* Mon Mar 02 2009 Anssi Hannula <anssi@zarb.org> 10.0.22.87-1plf2009.1
- new version

* Sat Feb 21 2009 Anssi Hannula <anssi@zarb.org> 10.0.15.3-1plf2009.1
- new version
- update instructions in case of failed download

* Wed Oct 22 2008 Anssi Hannula <anssi@zarb.org> 10.0.12.36-2plf2009.1
- requires libnss3 and libnspr4 specifically, instead of the library names,
  as those are provided by multiple packages on some releases

* Sun Oct 19 2008 Anssi Hannula <anssi@zarb.org> 10.0.12.36-1plf2009.1
- new version

* Tue Apr 15 2008 Anssi Hannula <anssi@zarb.org> 9.0.124.0-1plf2009.0
- new version
- suggests libflashsupport (#193)
- adapt conflicts to new Mandriva restricted FlashPlayer packages

* Fri Dec 07 2007 Anssi Hannula <anssi@zarb.org> 9.0.115.0-2plf2008.1
- better error message on md5sum mismatch (#178)
- fix error on upgrade (#178)
- use versioned rpm instead of tarball (#178)

* Thu Dec  6 2007 Götz Waschk <goetz@zarb.org> 9.0.115.0-1plf2008.1
- new version

* Sun Oct 14 2007 Anssi Hannula <anssi@zarb.org> 9.0.64.0-1plf2008.0
- 9.0.64.0 (Colin Guthrie)

* Wed Jul 11 2007 Anssi Hannula <anssi@zarb.org> 9.0.48.0-1plf2008.0
- 9.0.48.0

* Sun Jan 21 2007 Anssi Hannula <anssi@zarb.org> 9.0.31.0-1plf2007.1
- 9.0.31.0

* Tue Nov 21 2006 Götz Waschk <goetz@zarb.org> 9.0.21.78-1plf2007.1
- new version

* Sat Nov 11 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-4plf2007.1
- add additional check in postun on x86_64
- use ndiswrapper -i instead of -u on upgrade on x86_64

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-3plf2007.1
- manage nspluginwrapper automatically on x86_64
- add conflicts

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-2plf2007.1
- add manual dependencies

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-1plf2007.1
- initial PLF release
